import Web3 from "web3";
let web3: any;
declare var window: any;

export function loginWithMetamask(_networkId: number, message: string) {
  return new Promise(async (resolve, reject) => {
    try {
      console.log("Metamask:", window.ethereum.isMetaMask);

      if (window.ethereum.isMetaMask) {
        web3 = new Web3(window.ethereum);
        try {
          // Requestv account access if needed
          await window.ethereum.enable();
          const accounts = await web3.eth.getAccounts();
          const networkId = await web3.eth.net.getId();
          console.log("accounts:", accounts);
          console.log("networkid:", networkId);

          if (networkId !== _networkId) {
            console.log("change");

            await window.ethereum.request({
              method: "wallet_switchEthereumChain",
              params: [{ chainId: web3.utils.toHex(_networkId) }],
            });
            //   throw Error("Please switch to the correct network id!!");
          }

          // sign the message
          const receipt = await web3.eth.personal.sign(
            message,
            accounts[0],
            ""
          );
          console.log("receipt:", receipt);
          resolve({ account: accounts[0], msg_receipt: receipt });
        } catch (error) {
          console.log("error", error);
          reject("Error while login with metamask");
        }
      } else {
        reject("Metamask wallet not found!!");
      }
    } catch (error) {
      console.log("error:", error);
      reject();
    }
  });
}
